package com.DeviceTest;

import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.SpannableStringBuilder;
import android.text.TextUtils;
import android.text.style.ForegroundColorSpan;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.DeviceTest.helper.ControlButtonUtil;
import com.DeviceTest.helper.ExeCommand;

import java.util.Timer;
import java.util.TimerTask;

/**
 * Created by Administrator on 2018/1/10 0010.
 * 钱箱测试
 */

public class RJ12Activity extends Activity {

    private final String TAG = "RJ12Activity";
    private TextView statusText;
    private String status;
    private boolean isOpen;
    private boolean isClose;
    private int selectStatusCount;
    private String statusValue;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.rj12_test_layout);
        ControlButtonUtil.initControlButtonView(this);
        ((Button) findViewById(R.id.btn_Pass)).setVisibility(View.INVISIBLE);
        statusText = (TextView) findViewById(R.id.rj12_status_text);
        Button button = (Button) findViewById(R.id.rj12_button);
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cmdGpioPwrOn();
            }
        });
        timer.schedule(task, 0, 1000);
    }

    Timer timer = new Timer();
    TimerTask task = new TimerTask() {
        @Override
        public void run() {
            readStatus();
        }
    };

    public void readStatus() {
        String cmd = "cat /sys/class/neostra_gpioctl/dev/gpioctl_sns" + "\n";
        ExeCommand exeCommand = new ExeCommand();
        status = exeCommand.run(cmd, 10000).getResult();
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                selectStatusCount++;
                if (selectStatusCount == 1) {
                    statusValue = status.trim();
                }
                //0为开启，1为关闭
                if (!TextUtils.isEmpty(status) && status.trim().equals("0")) {
                    String value = String.format(getString(R.string.rj12_status), getString(R.string.open), getString(R.string.close));
                    int index = value.indexOf(getString(R.string.open), 0);
                    int lastIndex = getString(R.string.open).length();
                    SpannableStringBuilder ssb = new SpannableStringBuilder(value);
                    ssb.setSpan(new ForegroundColorSpan(Color.GREEN), index, lastIndex + index, Spannable.SPAN_EXCLUSIVE_INCLUSIVE);
                    statusText.setText(ssb);
                    if (!TextUtils.isEmpty(statusValue) && (!statusValue.equals("0") || isClose)) {//如果第一次进入时为关闭状态，则代表打开过钱箱
                        isOpen = true;
                    }
                } else {
                    String value = String.format(getString(R.string.rj12_status), getString(R.string.close), getString(R.string.open));
                    int index = value.indexOf(getString(R.string.close), 0);
                    int lastIndex = getString(R.string.close).length();
                    SpannableString ssb = new SpannableString(value);
                    ssb.setSpan(new ForegroundColorSpan(Color.RED), index, lastIndex + index, Spannable.SPAN_EXCLUSIVE_INCLUSIVE);
                    statusText.setText(ssb);
                    if (!TextUtils.isEmpty(statusValue) && (statusValue.equals("0") || isOpen)) {//如果第一次进入时为打开状态，则代表已关闭过钱箱
                        isClose = true;
                    }
                }
                if (isOpen && isClose) {
                    ((Button) findViewById(R.id.btn_Pass)).setVisibility(View.VISIBLE);
                }
            }
        });
        exeCommand.closeStream();
    }

    public void cmdGpioPwrOn() {
        String cmd = "echo 1 > /sys/class/neostra_gpioctl/dev/gpioctl " + "\n";
        try {
            Process exeEcho = Runtime.getRuntime().exec("sh");
            exeEcho.getOutputStream().write(cmd.getBytes());
            exeEcho.getOutputStream().flush();
            Log.i(TAG, " " + cmd);
//            statusText.setText(String.format(getString(R.string.rj12_status), getString(R.string.open)));
        } catch (Exception e) {
            Log.i(TAG, "cmdGpioPwrOn faild");
            ((Button) findViewById(R.id.btn_Fail)).setVisibility(View.VISIBLE);
        }
    }

    public void cmdGpioPwrOff() {
        String cmd = "echo 0 > /sys/class/neostra_gpioctl/dev/gpioctl " + "\n";
        try {
            Process exeEcho = Runtime.getRuntime().exec("sh");
            exeEcho.getOutputStream().write(cmd.getBytes());
            exeEcho.getOutputStream().flush();
            Log.i(TAG, " " + cmd);
        } catch (Exception e) {
            Log.i(TAG, "cmdGpioPwrOff faild");
        }
    }

    public boolean dispatchKeyEvent(KeyEvent event) {
        if (event.getKeyCode() == KeyEvent.KEYCODE_BACK) {
            return false;
        }
        return super.dispatchKeyEvent(event);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (null != timer) {
            timer.cancel();
        }
    }
}
